## guile-3.0 3.0.10%2Breally3.0.10

=== debian/control ===
Source: guile-3.0
Section: interpreters
Priority: optional
Maintainer: Rob Browning <rlb@defaultvalue.org>
Build-Depends: libtool, debhelper-compat (= 10), autoconf, automake,
 gperf,
 guile-3.0:native <cross>,
 libncurses-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
 libunistring-dev, libgc-dev, libffi-dev, pkgconf
Standards-Version: 3.7.2
Homepage: http://www.gnu.org/software/guile/

Package: guile-3.0
Section: lisp
Architecture: any
Multi-Arch: allowed
Provides: guile
Depends: guile-3.0-libs (= ${binary:Version}), ${shlibs:Depends},
 ${misc:Depends}
Suggests: guile-3.0-doc
Description: GNU extension language and Scheme interpreter
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

Package: guile-3.0-dev
Section: lisp
Architecture: any
Provides: libguile-dev (= ${binary:Version})
Conflicts: guile-1.8, libguile-dev (<< 2.2.7+1-4), guile-3.0-dev (<< 3.0.1+1-2)
Depends: ${shlibs:Depends}, guile-3.0:any (= ${binary:Version}),
 guile-3.0-libs (= ${binary:Version}), libc-dev,
 libncurses-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,
 pkgconf, ${misc:Depends}
Description: Development files for Guile 3.0
 This package contains files needed for development using Guile 3.0.
 .
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

Package: guile-3.0-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: dpkg (>= 1.15.4), ${misc:Depends}
Description: Documentation for Guile 3.0
 This package contains the Guile documentation, including the Guile
 Reference Manual.
 .
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

Package: guile-3.0-libs
Section: lisp
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core Guile libraries
 Guile is a Scheme implementation designed for real world programming,
 providing a rich Unix interface, a module system, an interpreter, and
 many extension languages.  Guile can be used as a standard #! style
 interpreter, via #!/usr/bin/guile, or as an extension language for
 other applications via libguile.

## guile-3.0 3.0.10+really3.0.9

=== debian/changelog ===
guile-3.0 (3.0.10+really3.0.9-1) unstable; urgency=medium

  * Downgrade to 3.0.9-1 for now.  Guile 3.0.10 appears to have an
    unresolved problem with 32-bit architectures.  Thanks to Paul Gevers
    for reporting the problem. (Closes: 1077930)

  * debian/rules: set PACKAGE_PACKAGER_VERSION to DEB_VERSION.  Drop
    vestigial deb_src_rev and deb_src_src_rev.

  * debian/rules: get upstream_ver via pkg-info DEB_VERSION_UPSTREAM.
    Drop vestigial deb_src_ver.

  * debian/rules: get DEB_HOST_MULTIARCH via pkg-info architecture.mk.

  * debian/rules: get DEB_TARGET_ARCH via pkg-info architecture.mk.

  * debian/rules: check alternatives constraint via .SHELLSTATUS.

  * debian/rules: force deb_alt_priority to 3010 during downgrade.

  * Get upstream_version from GUILE-VERSION not debian/changelog.  Drop
    $(shout ...) etc., now that everything's been migrated to
    .SHELLSTATUS.

 -- Rob Browning <rlb@defaultvalue.org>  Sat, 31 Aug 2024 17:08:23 -0500

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
 Provides: libguile-dev (= ${binary:Version})
 Conflicts: guile-1.8, libguile-dev (<< 2.2.7+1-4), guile-3.0-dev (<< 3.0.1+1-2)
 Depends: ${shlibs:Depends}, guile-3.0:any (= ${binary:Version}),
- guile-3.0-libs (= ${binary:Version}), libc-dev,
+ guile-3.0-libs (= ${binary:Version}), libc6-dev,
  libncurses-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,
  pkgconf, ${misc:Depends}
 Description: Development files for Guile 3.0
@@ -47,7 +47,7 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: dpkg (>= 1.15.4), ${misc:Depends}
+Depends: dpkg (>= 1.15.4) | install-info, ${misc:Depends}
 Description: Documentation for Guile 3.0
  This package contains the Guile documentation, including the Guile
  Reference Manual.

=== debian/rules ===
#!/usr/bin/make -f

# New stable upstream release TODO:
#   s/A.B/C.D/go in debian/control.
#   Adjust debian/changelog.
#   Adjust "ver" variables below.
#   Adjust debian/guile-libs.lintian.
#   Adjust debian/.gitignore.
#   Fix deb_alt_priority below.

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/dpkg/pkg-info.mk

SHELL := /bin/bash

pf := set -o pipefail

# Make sure the build process doesn't touch the real HOME.
export HOME := $(CURDIR)/debian/no-trespassing

# Keep this in sync with guile-doc.install
expected_info := guile.info $(foreach n,1 2 3 4 5 6 7 8 9 10 11,guile.info-$(n))

joblimit := $(or $(DEB_BUILD_OPTION_PARALLEL),1)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE := 1

upstream_ver != debian/upstream-version
ifneq (0,$(.SHELLSTATUS))
  $(error debian/upstream-version exit status $(.SHELLSTATUS))
endif
deb_src_maj_ver := $(word 1,$(subst ., ,$(upstream_ver)))
deb_src_min_ver := $(word 2,$(subst ., ,$(upstream_ver)))
deb_src_mic_ver := $(word 3,$(subst ., ,$(upstream_ver)))

deb_src_eff_ver := $(deb_src_maj_ver).$(deb_src_min_ver)
deb_pkg_basename := guile-$(deb_src_eff_ver)
deb_guile_bin_path := /usr/bin/guile-$(deb_src_eff_ver)

$(shell x='$(deb_src_min_ver)';  [ "$${x}" -lt 1000 ])
ifneq (0,$(.SHELLSTATUS))
  $(error ERROR: alternatives priority expects min version < 1000)
endif

# Up to and including some releases of 2.0.11, this was (incorrectly)
# majminmic (i.e. 2011 for 2.0.11).  As of 3.0, we switched to this,
# i.e. 3.0 -> 3000, 3.1 -> 3001, 3.2 -> 3002, etc.
deb_alt_priority := 3010

ifneq ($(DEB_HOST_MULTIARCH),)
  march = $(DEB_HOST_MULTIARCH)/
else
  march =
endif

ifneq (,$(filter $(DEB_TARGET_ARCH),armel armhf x32))
  deb_config_args += --enable-jit=no
endif
ifneq (,$(filter $(DEB_TARGET_ARCH),alpha))
  deb_config_args += --without-threads
endif

export DEB_CFLAGS_MAINT_APPEND := \
  -DPACKAGE_PACKAGER='"Debian"' \
  -DPACKAGE_PACKAGER_VERSION='"$(DEB_VERSION)"' \
  -DPACKAGE_PACKAGER_BUG_REPORTS='"http://www.debian.org/Bugs/Reporting"'

# https://debbugs.gnu.org/29464
export DEB_CFLAGS_MAINT_APPEND += -fno-stack-protector

define checkdir
  dh_testdir debian/guile.postinst
endef

%:
	dh $@

.PHONY: check-vars
check-vars:
	@echo "    upstream_ver:" $(upstream_ver)
	@echo "deb_pkg_basename:" $(deb_pkg_basename)
	@echo " deb_src_eff_ver:" $(deb_src_eff_ver)
	@echo " deb_src_maj_ver:" $(deb_src_maj_ver)
	@echo " deb_src_min_ver:" $(deb_src_min_ver)
	@echo " deb_src_mic_ver:" $(deb_src_mic_ver)
	@echo "deb_alt_priority:" $(deb_alt_priority)

# For now, assumes there are no "|" characters in the expansions.
debian/autogen.sed: debian/rules debian/changelog
	echo "s|@UPSTREAM_VER@|$(upstream_ver)|g" > "$@.tmp"
	echo "s|@DEB_SRC_MAJ_VER@|$(deb_src_maj_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_MIN_VER@|$(deb_src_min_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_MIC_VER@|$(deb_src_mic_ver)|g" >> "$@.tmp"
	echo "s|@DEB_SRC_EFF_VER@|$(deb_src_eff_ver)|g" >> "$@.tmp"
	echo "s|@DEB_PKG_BASENAME@|$(deb_pkg_basename)|g" >> "$@.tmp"
	echo "s|@DEB_ALT_PRIORITY@|$(deb_alt_priority)|g" >> "$@.tmp"
	echo "s|@MARCH@|$(march)|g" >> "$@.tmp"
	mv "$@.tmp" "$@"

autogen_install_files := $(addprefix debian/, \
  guile-$(deb_src_eff_ver).install \
  guile-$(deb_src_eff_ver).links \
  guile-$(deb_src_eff_ver).menu \
  guile-$(deb_src_eff_ver).undocumented \
  guile-$(deb_src_eff_ver)-dev.install \
  guile-$(deb_src_eff_ver)-doc.README.Debian \
  guile-$(deb_src_eff_ver)-doc.install \
  guile-$(deb_src_eff_ver)-libs.install \
  guile-$(deb_src_eff_ver)-libs.lintian-overrides)

autogen_installdeb_files := $(addprefix debian/, \
  guile-$(deb_src_eff_ver).postinst \
  guile-$(deb_src_eff_ver).prerm \
  guile-$(deb_src_eff_ver)-dev.postinst \
  guile-$(deb_src_eff_ver)-dev.prerm \
  guile-$(deb_src_eff_ver)-doc.postinst \
  guile-$(deb_src_eff_ver)-doc.prerm \
  guile-$(deb_src_eff_ver)-libs.postinst \
  guile-$(deb_src_eff_ver)-libs.prerm \
  guile-$(deb_src_eff_ver)-libs.triggers)

debian/source/lintian-overrides: debian/source-lintian-overrides.in debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver).%: debian/guile.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver)-dev.%: debian/guile-dev.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver)-doc.%: debian/guile-doc.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"
debian/guile-$(deb_src_eff_ver)-libs.%: debian/guile-libs.% debian/autogen.sed
	sed -f debian/autogen.sed "$<" > "$@.tmp"
	mv "$@.tmp" "$@"

debian/guile-$(deb_src_eff_ver)-doc.postinst:
	DEB_PKG_BASENAME="$(deb_pkg_basename)" \
	DEB_INFO_SUBDIR="$(deb_pkg_basename)" \
	DEB_ALT_PRIORITY="$(deb_alt_priority)" \
	  debian/guile-doc.postinst.gen $(addprefix doc/ref/,$(expected_info)) \
	    > "$@".tmp
	mv "$@.tmp" "$@"

override_dh_testdir: debian/source/lintian-overrides
	$(checkdir)

override_dh_autoreconf:
	echo '$(upstream_ver)' > .version
	cp -a .version .tarball-version
	dh_autoreconf ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- --disable-error-on-warning --disable-rpath \
	  --program-suffix "-$(deb_src_eff_ver)" $(deb_config_args)

# Because some of the bootstrapping files compile for a very long time
# with no output, the buildds don't have per-package limits, and we
# don't want to raise the global limit that high for the slower
# architectures.
override_dh_auto_build:
	timeout 10h bash \
	  -c 'while true; do echo "still going" 1>&2; sleep 600; done' & \
	trap "kill $$!" EXIT \
	&& $(MAKE) -j "$(joblimit)"

override_dh_auto_clean:
        # If Makefile doesn't exist GNUmakefile will abort on distclean.
	if test -e Makefile; then make distclean; fi

override_dh_clean:
	dh_clean $(autogen_install_files) $(autogen_installdeb_files) \
	  .tarball-version \
	  .version \
	  blarg-clean \
	  bootstrap/ice-9/ \
	  bootstrap/language/ \
	  bootstrap/srfi/ \
	  bootstrap/system/ \
	  debian/autogen.sed \
	  doc/r5rs/r5rs.info \
	  doc/ref/autoconf-macros.texi \
	  doc/ref/effective-version.texi \
	  doc/ref/guile.info \
	  doc/ref/guile.info-1 \
	  doc/ref/guile.info-10 \
	  doc/ref/guile.info-11 \
	  doc/ref/guile.info-2 \
	  doc/ref/guile.info-3 \
	  doc/ref/guile.info-4 \
	  doc/ref/guile.info-5 \
	  doc/ref/guile.info-6 \
	  doc/ref/guile.info-7 \
	  doc/ref/guile.info-8 \
	  doc/ref/guile.info-9 \
	  doc/ref/stamp-vti \
	  doc/ref/version.texi \
	  filesys-test-link.tmp \
	  guile-procedures.txt \
	  libguile/c-tokenize.c \
	  libguile/cpp-E.c \
	  libguile/cpp-SIG.c \
	  libguile/vm-operations.h

# Info pages are installed to /usr/share/info/guile-X.Y/ via
# guile-doc.install, and handled via update-alternatives.
override_dh_installinfo:
	true

override_dh_auto_install: $(autogen_install_files)
	make DESTDIR="$$(pwd)/debian/tmp" INSTALL='install -p' install
	rm -f debian/tmp/usr/lib/$(march)libguile*.la
	mkdir -p debian/tmp/usr/share/doc/$(deb_pkg_basename)-dev
	cp -a examples debian/tmp/usr/share/doc/$(deb_pkg_basename)-dev
	cd debian/tmp/usr/share/doc/$(deb_pkg_basename)-dev/examples \
	  && rm Makefile Makefile.in

gdb_ext := \
  debian/$(deb_pkg_basename)-libs/usr/lib/$(march)libguile-$(deb_src_eff_ver).so*-gdb.scm
gdb_ext_dir := debian/$(deb_pkg_basename)-dev/usr/share/gdb/auto-load

override_dh_install-arch: $(autogen_install_files)
	cd debian/tmp/usr/bin && mv -i guile-$(deb_src_eff_ver) guile
	cd debian/tmp/usr/share/aclocal && mv -i guile.m4 guile-$(deb_src_eff_ver).m4
	dh_install -a
	dh_missing -a --fail-missing \
	  -Xusr/lib/$(march)guile/$(deb_src_eff_ver)/extensions/guile-readline.a \
	  -Xusr/lib/$(march)guile/$(deb_src_eff_ver)/extensions/guile-readline.la
	test -e $(gdb_ext)
	mkdir -p $(gdb_ext_dir)
	mv $(gdb_ext) $(gdb_ext_dir)

override_dh_install-indep: $(autogen_install_files)

## guile-3.0 3.0.10+really3.0.10

=== debian/changelog ===
guile-3.0 (3.0.10+really3.0.10-5) unstable; urgency=medium

  * debian/rules: just always try df -h.  Instead of avoiding df -h on
    hurd-*, just try it everywhere ignoring failures.  The previous filter
    wasn't quite right, and it turns out, wasn't appropriate anyway.  It
    looks like the issue is with the buildd's environment, not hurd-* in
    general.

  * debian/rules: compile with -std=gnu17 for GCC 15.  Guile's not yet
    compatible with C23, now the default in GCC 15, so for the time being,
    explicitly restore the GCC 14 default with -std=gnu17.  Thanks to
    Matthias Klose for reporting the problem. (Closes: 1096788)

  * Remove debian/source/lintian-overrides.in.  Lintan considers the
    existence of that path to be an error, so remove it and just generate
    the corresponding lintian-overrides content directly.

  * debian/control: add explicit libcrypt-dev Build-Depends.  Thanks to
    Helmut Grohne for reporting the issue. (Closes: 1106980, 1102911)

  * guile-libs.lintian-overrides: add missing brackets.

  * debian/rules: compile with -ffat-lto-objects to avoid over-stripping.
    Without that, dh_strip leaves libguile-3.0.a with no code sections:
    https://lintian.debian.org/tags/no-code-sections.html

  * Fix in-tree cross-compilation builds.  Add
    0025-build-Fix-in-tree-cross-compilation-build.patch to address the
    issue. (Closes: 1102606)

  * debian/copyright: refresh.

 -- Rob Browning <rlb@defaultvalue.org>  Mon, 15 Sep 2025 21:54:56 -0500

guile-3.0 (3.0.10+really3.0.10-4) unstable; urgency=medium

  * debian/rules: avoid df -h on hurd-* (include amd64).

  * guile-libs.lintian-overrides: match guile-procedures.txt arch via *.
    Replace @MARCH@ with * to avoid multi-arch conflicts.  Thanks to
    Helmut Grohne for reporting the issue. (Closes: 1095251)

  * debian/rules: given kernel fix; re-enable threads on alpha.  This will
    require rebuilding all of the reverse dependencies.
    cf. 1b4313b4f309cdc87a79a994cf426d3edf5bc876 Thanks to John Paul
    Adrian Glaubitz for reporting the issue.  (Closes: 1095880)

 -- Rob Browning <rlb@defaultvalue.org>  Sun, 16 Feb 2025 13:31:41 -0600

guile-3.0 (3.0.10+really3.0.10-3) unstable; urgency=medium

  * debian/rules: avoid hurd-i386 df -h; it doesn't work there.

  * debian/rules: include timestamp in "still going" messages.  Helps give
    some idea how quickly we're making progress on slower hosts.

  * Don't crash when printing a port's name in some environments.  Since
    ttyname() can return ENODEV in some environments, don't thrown an
    exception, just include the integer descriptor instead.  Add
    0024-fport_print-handle-ttyname-ENODEV.patch to address the issue.

 -- Rob Browning <rlb@defaultvalue.org>  Fri, 17 Jan 2025 13:35:15 -0600

guile-3.0 (3.0.10+really3.0.10-2) experimental; urgency=medium

  * debian/rules: report df -h to help with test failure diagnosis.  Run
    df -h so the filesystem types will be in the output, to help when
    reasoning about test failures, e.g. ports.test.

  * Add debian/bin/path-fs to help with fs-sensitive tests.  This will be
    used to avoid running the ports.test seek data/hole tests on
    filesystems that might not support the expected semantics.  Taken with
    the author's permission (mine), from bup.

  * Add upstream patch guarding ports seek data/hole tests to debian.  The
    upstream patch only omits the tests on darwin, but we'll extend it to
    omit the tests unless the filesystem is one we know should have the
    expected semantics.  Add
    0022-tests-Skip-hole-related-port-tests-on-Darwin.patch to include the
    relevant changes.

  * Skip ports.test seek tests unless filesystem looks suitable.  Add
    0023-Skip-ports.test-seek-tests-unless-filesystem-looks-s.patch to
    address the issue.

 -- Rob Browning <rlb@defaultvalue.org>  Wed, 15 Jan 2025 13:05:41 -0600

guile-3.0 (3.0.10+really3.0.10-1) experimental; urgency=medium

  * debian/rules: check alternatives constraint via .SHELLSTATUS.

  * Get upstream_version from GUILE-VERSION not debian/changelog.  This
    matters whenever we have to downgrade via DEBIAN+reallyUPSTREAM.

  * Fix 3.0.10 32-bit support and i386 math.
    Add these upstream patches to address the issues:
      0008-test-hashing-support-32-bit.patch
      0009-More-thorough-lowering-of-lognot-to-CPS.patch
      0010-Fix-intset-fold-right-on-transient-intsets.patch
      0011-Add-a-workaround-for-pre-3.0.10-incorrect-inlinable-.patch
      0012-Remove-needless-constraints-in-type-range-analysis.patch
      0013-Narrow-parameter-of-logand-immediate-if-no-bits-used.patch
      0014-Partially-revert-d579848cb5d65440af5afd9c89686286655.patch
      0015-Fix-fixpoint-needed-bits-computation-in-specialize-n.patch
      0016-Fix-boxing-of-non-fixnum-negative-u64-values.patch
      0017-Tighten-up-range-inference-for-scm-u64-truncate.patch
      0018-Run-sigbits-fixpoint-based-on-use-def-graph-not-cfg.patch
      0019-Compile-with-fexcess-precision-standard-for-i-3456-8.patch
      0020-Eight-byte-align-statically-allocated-stringbufs.patch

  * debian/rules: rely on .DELETE_ON_ERROR:.

  * Move source lintian-overrides to preferred debian/source/ location.

  * guile-libs.lintian-overrides: remove unused ccache/*.go overrides.

  * guile-libs.lintian-overrides: override warning about procedures.txt.

  * Mark repl-server inter-protocol attack test as unresolved.  It can
    fail intermittently when the write-request fails during parallel test
    runs (at least).  Add
    0021-Mark-inter-protocol-attack-test-unresolved-if-write-.patch to
    address the issue.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 14 Jan 2025 16:27:59 -0600

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,10 @@
 Section: interpreters
 Priority: optional
 Maintainer: Rob Browning <rlb@defaultvalue.org>
-Build-Depends: libtool, debhelper-compat (= 10), autoconf, automake,
- gperf,
- guile-3.0:native <cross>,
- libncurses-dev, libreadline-dev, libltdl-dev, libgmp-dev, texinfo, flex,
- libunistring-dev, libgc-dev, libffi-dev, pkgconf
+Build-Depends: autoconf, automake, debhelper-compat (= 10), flex, gperf,
+ guile-3.0:native <cross>, libcrypt-dev, libffi-dev, libgc-dev,
+ libgmp-dev, libltdl-dev, libncurses-dev, libreadline-dev, libtool,
+ libunistring-dev, pkgconf, texinfo
 Standards-Version: 3.7.2
 Homepage: http://www.gnu.org/software/guile/
 
@@ -30,10 +29,11 @@
 Architecture: any
 Provides: libguile-dev (= ${binary:Version})
 Conflicts: guile-1.8, libguile-dev (<< 2.2.7+1-4), guile-3.0-dev (<< 3.0.1+1-2)
-Depends: ${shlibs:Depends}, guile-3.0:any (= ${binary:Version}),
- guile-3.0-libs (= ${binary:Version}), libc6-dev,
- libncurses-dev, libreadline6-dev, libltdl-dev, libgmp-dev, libgc-dev,
- pkgconf, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends},
+ guile-3.0-libs (= ${binary:Version}),
+ guile-3.0:any (= ${binary:Version}),
+ libc-dev, libcrypt-dev, libgc-dev, libgmp-dev, libltdl-dev,
+ libncurses-dev, libreadline6-dev, pkgconf
 Description: Development files for Guile 3.0
  This package contains files needed for development using Guile 3.0.
  .
@@ -47,7 +47,7 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: dpkg (>= 1.15.4) | install-info, ${misc:Depends}
+Depends: dpkg (>= 1.15.4), ${misc:Depends}
 Description: Documentation for Guile 3.0
  This package contains the Guile documentation, including the Guile
  Reference Manual.

=== debian/rules ===
--- 
+++ 
@@ -8,13 +8,17 @@
 #   Adjust debian/.gitignore.
 #   Fix deb_alt_priority below.
 
+.DELETE_ON_ERROR:
+
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildopts.mk
 include /usr/share/dpkg/pkg-info.mk
 
 SHELL := /bin/bash
 
-pf := set -o pipefail
+# Escape content for single-quoted expansions like '$(foo)'
+esc = $(subst ','\'',$(1))
+# This quote unconfuses emacs makefile-gmake-mode: '
 
 # Make sure the build process doesn't touch the real HOME.
 export HOME := $(CURDIR)/debian/no-trespassing
@@ -27,6 +31,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE := 1
 
+# Get the version from GUILE-VERSION to handle any +really downgrades.
 upstream_ver != debian/upstream-version
 ifneq (0,$(.SHELLSTATUS))
   $(error debian/upstream-version exit status $(.SHELLSTATUS))
@@ -47,7 +52,7 @@
 # Up to and including some releases of 2.0.11, this was (incorrectly)
 # majminmic (i.e. 2011 for 2.0.11).  As of 3.0, we switched to this,
 # i.e. 3.0 -> 3000, 3.1 -> 3001, 3.2 -> 3002, etc.
-deb_alt_priority := 3010
+deb_alt_priority := $(deb_src_maj_ver)$(shell printf "%03d" $(deb_src_min_ver))
 
 ifneq ($(DEB_HOST_MULTIARCH),)
   march = $(DEB_HOST_MULTIARCH)/
@@ -58,21 +63,15 @@
 ifneq (,$(filter $(DEB_TARGET_ARCH),armel armhf x32))
   deb_config_args += --enable-jit=no
 endif
-ifneq (,$(filter $(DEB_TARGET_ARCH),alpha))
-  deb_config_args += --without-threads
-endif
 
 export DEB_CFLAGS_MAINT_APPEND := \
   -DPACKAGE_PACKAGER='"Debian"' \
   -DPACKAGE_PACKAGER_VERSION='"$(DEB_VERSION)"' \
   -DPACKAGE_PACKAGER_BUG_REPORTS='"http://www.debian.org/Bugs/Reporting"'
 
-# https://debbugs.gnu.org/29464
 export DEB_CFLAGS_MAINT_APPEND += -fno-stack-protector
-
-define checkdir
-  dh_testdir debian/guile.postinst
-endef
+export DEB_CFLAGS_MAINT_APPEND += -std=gnu17
+export DEB_CFLAGS_MAINT_APPEND += -flto -ffat-lto-objects
 
 %:
 	dh $@
@@ -86,18 +85,18 @@
 	@echo " deb_src_min_ver:" $(deb_src_min_ver)
 	@echo " deb_src_mic_ver:" $(deb_src_mic_ver)
 	@echo "deb_alt_priority:" $(deb_alt_priority)
+	@echo "           march:" $(march)
 
 # For now, assumes there are no "|" characters in the expansions.
 debian/autogen.sed: debian/rules debian/changelog
-	echo "s|@UPSTREAM_VER@|$(upstream_ver)|g" > "$@.tmp"
-	echo "s|@DEB_SRC_MAJ_VER@|$(deb_src_maj_ver)|g" >> "$@.tmp"
-	echo "s|@DEB_SRC_MIN_VER@|$(deb_src_min_ver)|g" >> "$@.tmp"
-	echo "s|@DEB_SRC_MIC_VER@|$(deb_src_mic_ver)|g" >> "$@.tmp"
-	echo "s|@DEB_SRC_EFF_VER@|$(deb_src_eff_ver)|g" >> "$@.tmp"
-	echo "s|@DEB_PKG_BASENAME@|$(deb_pkg_basename)|g" >> "$@.tmp"
-	echo "s|@DEB_ALT_PRIORITY@|$(deb_alt_priority)|g" >> "$@.tmp"
-	echo "s|@MARCH@|$(march)|g" >> "$@.tmp"
-	mv "$@.tmp" "$@"
+	echo "s|@UPSTREAM_VER@|$(upstream_ver)|g" > $@
+	echo "s|@DEB_SRC_MAJ_VER@|$(deb_src_maj_ver)|g" >> $@
+	echo "s|@DEB_SRC_MIN_VER@|$(deb_src_min_ver)|g" >> $@
+	echo "s|@DEB_SRC_MIC_VER@|$(deb_src_mic_ver)|g" >> $@
+	echo "s|@DEB_SRC_EFF_VER@|$(deb_src_eff_ver)|g" >> $@
+	echo "s|@DEB_PKG_BASENAME@|$(deb_pkg_basename)|g" >> $@
+	echo "s|@DEB_ALT_PRIORITY@|$(deb_alt_priority)|g" >> $@
+	echo "s|@MARCH@|$(march)|g" >> $@
 
 autogen_install_files := $(addprefix debian/, \
   guile-$(deb_src_eff_ver).install \
@@ -121,32 +120,30 @@
   guile-$(deb_src_eff_ver)-libs.prerm \
   guile-$(deb_src_eff_ver)-libs.triggers)
 
-debian/source/lintian-overrides: debian/source-lintian-overrides.in debian/autogen.sed
-	sed -f debian/autogen.sed "$<" > "$@.tmp"
-	mv "$@.tmp" "$@"
+debian/source/lintian-overrides: debian/rules debian/changelog
+	printf '%s source: missing-field-in-dep5-copyright\n' \
+	  '$(call esc,$(deb_pkg_basename))' > $@
+
 debian/guile-$(deb_src_eff_ver).%: debian/guile.% debian/autogen.sed
-	sed -f debian/autogen.sed "$<" > "$@.tmp"
-	mv "$@.tmp" "$@"
+	sed -f debian/autogen.sed "$<" > $@
 debian/guile-$(deb_src_eff_ver)-dev.%: debian/guile-dev.% debian/autogen.sed
-	sed -f debian/autogen.sed "$<" > "$@.tmp"
-	mv "$@.tmp" "$@"
+	sed -f debian/autogen.sed "$<" > $@
 debian/guile-$(deb_src_eff_ver)-doc.%: debian/guile-doc.% debian/autogen.sed
-	sed -f debian/autogen.sed "$<" > "$@.tmp"
-	mv "$@.tmp" "$@"
+	sed -f debian/autogen.sed "$<" > $@
 debian/guile-$(deb_src_eff_ver)-libs.%: debian/guile-libs.% debian/autogen.sed
-	sed -f debian/autogen.sed "$<" > "$@.tmp"
-	mv "$@.tmp" "$@"
+	sed -f debian/autogen.sed "$<" > $@
 
 debian/guile-$(deb_src_eff_ver)-doc.postinst:
 	DEB_PKG_BASENAME="$(deb_pkg_basename)" \
 	DEB_INFO_SUBDIR="$(deb_pkg_basename)" \
 	DEB_ALT_PRIORITY="$(deb_alt_priority)" \
 	  debian/guile-doc.postinst.gen $(addprefix doc/ref/,$(expected_info)) \
-	    > "$@".tmp
-	mv "$@.tmp" "$@"
+	    > $@
 
 override_dh_testdir: debian/source/lintian-overrides
-	$(checkdir)
+        # See what we have (relevant to tests like ports.test)
+	df -h || true # df didn't work on some hurd buildds
+	dh_testdir debian/guile.postinst
 
 override_dh_autoreconf:
 	echo '$(upstream_ver)' > .version
@@ -163,7 +160,7 @@
 # architectures.
 override_dh_auto_build:
 	timeout 10h bash \
-	  -c 'while true; do echo "still going" 1>&2; sleep 600; done' & \
+	  -c 'while true; do printf "still going %(%F %T)T\n" 1>&2; sleep 600; done' & \
 	trap "kill $$!" EXIT \
 	&& $(MAKE) -j "$(joblimit)"
 
@@ -228,9 +225,3 @@
 	dh_install -a
 	dh_missing -a --fail-missing \
 	  -Xusr/lib/$(march)guile/$(deb_src_eff_ver)/extensions/guile-readline.a \
-	  -Xusr/lib/$(march)guile/$(deb_src_eff_ver)/extensions/guile-readline.la
-	test -e $(gdb_ext)
-	mkdir -p $(gdb_ext_dir)
-	mv $(gdb_ext) $(gdb_ext_dir)
-
-override_dh_install-indep: $(autogen_install_files)

## guile-3.0 3.0.11

=== libguile/lightening/tests/Makefile ===
TESTS ?= $(sort $(basename $(wildcard *.c)))
TARGETS ?= native ia32 aarch64 armv7 riscv

# Suitable values of cross-compiler variables for Debian:
#
#   make test CC_IA32=i668-linux-gnu-gcc CC_AARCH64=aarch64-linux-gnu-gcc
#
# The relevant packages that you need to run this:
#
#   dpkg --add-architecture i386
#   dpkg --add-architecture arm64
#   apt-get update -qq
#   apt-get install -y \
#     libc6-dev:amd64 gcc make \
#     qemu binfmt-support qemu-user-static \
#     gcc-i686-linux-gnu libc6-dev-i386-cross libc6:i386 \
#     gcc-aarch64-linux-gnu libc6-dev-arm64-cross libc6:arm64\
#     gcc-riscv64-linux-gnu libc6-dev-riscv64-cross libc6:riscv64
#
CC = gcc
CC_IA32 ?= guix environment --pure -s i686-linux --ad-hoc gcc-toolchain -- gcc
CC_AARCH64 ?= guix environment --pure -s aarch64-linux --ad-hoc gcc-toolchain -- gcc
CC_ARMv7 ?= guix environment --pure -s armhf-linux --ad-hoc gcc-toolchain -- gcc
CC_RISCV ?= guix environment --pure -s riscv64-linux --ad-hoc gcc-toolchain -- gcc
CFLAGS ?= -Wall -O0 -g

all: $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))

check: $(addprefix test-$(TARGET),$(TARGETS))

test-%: $(addprefix test-%-,$(TESTS))
	@echo "Running unit tests..."
	@set -e; for test in $?; do \
	  echo "Testing: $$test"; \
	  ./$$test; \
	done
	@echo "Success."

.PHONY: test check

lightening-%.o: ../lightening.h ../lightening/*.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ -c ../lightening/lightening.c

test-native-%: %.c lightening-native.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-native.o $<

test-ia32-%: CC = $(CC_IA32)
test-ia32-%: %.c lightening-ia32.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-ia32.o $<

test-aarch64-%: CC = $(CC_AARCH64)
test-aarch64-%: %.c lightening-aarch64.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-aarch64.o $<

test-armv7-%: CC = $(CC_ARMv7)
test-armv7-%: %.c lightening-armv7.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-armv7.o $<

test-riscv-%: CC = $(CC_RISCV)
test-riscv-%: %.c lightening-riscv.o test.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -I.. -o $@ lightening-riscv.o $<

.PRECIOUS: $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))
.PRECIOUS: $(foreach TARGET,$(TARGETS),lightening-$(TARGET).o)

clean:
	rm -f $(foreach TARGET,$(TARGETS),$(addprefix test-$(TARGET)-,$(TESTS)))
	rm -f $(foreach TARGET,$(TARGETS),lightening-$(TARGET).o)

=== debian/changelog ===
guile-3.0 (3.0.11-2) unstable; urgency=medium

  * debian/rules: disable the riscv64 JIT for now; risv64 support was
    added in 3.0.11, but it's causing (at least) the guile-fibers tests to
    segfault.  Thanks to Paul Gevers for reporting the problem.
    (Closes: 1125508)

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 03 Feb 2026 13:30:07 -0600

guile-3.0 (3.0.11-1) unstable; urgency=medium

  * Upgrade to 3.0.11.

  * Update debian/changelog version for 3.0.11.

  * Update debian/copyright for 3.0.11.

  * Add basic autopkgtest.

 -- Rob Browning <rlb@defaultvalue.org>  Fri, 12 Dec 2025 21:20:26 -0600

guile-3.0 (3.0.10+really3.0.10-6) unstable; urgency=medium

  * Fix s390x build by being more persistent in the fluid gc test.  Add
    0026-fluids.test-be-more-determined-when-checking-fluid-g.patch to fix
    the problem.

 -- Rob Browning <rlb@defaultvalue.org>  Tue, 16 Sep 2025 12:14:56 -0500

=== debian/rules ===
--- 
+++ 
@@ -60,7 +60,8 @@
   march =
 endif
 
-ifneq (,$(filter $(DEB_TARGET_ARCH),armel armhf x32))
+# riscv64: https://bugs.debian.org/1125508
+ifneq (,$(filter $(DEB_TARGET_ARCH),armel armhf riscv64 x32))
   deb_config_args += --enable-jit=no
 endif
